using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Chart;
using Syncfusion.Drawing;

namespace DragDropDynamic
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
		private bool isDragging = false;
		private ChartRegion currentRegion = null;
		private double xmin;
		private double ymax;
		private double ymin;
		private double xmax;
		private Point chartAreaPoint;
		private System.Windows.Forms.ToolTip toolTip1;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InitializeControlSettings();
			
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
			this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
			this.SuspendLayout();
			// 
			// chartControl1
			// 
			this.chartControl1.Controls.Add(this.chartControl1.Legend);
			this.chartControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			// 
			// chartControl1.Legend
			// 
			this.chartControl1.Legend.Font = new System.Drawing.Font("Verdana", 10F);
			this.chartControl1.Legend.ItemsShadowColor = System.Drawing.Color.Gray;
			this.chartControl1.Legend.Location = new System.Drawing.Point(294, 192);
			this.chartControl1.Legend.Name = "";
			this.chartControl1.Legend.TabIndex = 3;
			this.chartControl1.Legend.Visible = false;
			this.chartControl1.Location = new System.Drawing.Point(0, 0);
			this.chartControl1.Name = "chartControl1";
			this.chartControl1.PrimaryXAxis.DrawGrid = false;
			this.chartControl1.PrimaryXAxis.LabelAligment = System.Drawing.StringAlignment.Center;
			this.chartControl1.PrimaryXAxis.Orientation = Syncfusion.Windows.Forms.Chart.ChartOrientation.Horizontal;
			this.chartControl1.PrimaryYAxis.DrawGrid = false;
			this.chartControl1.PrimaryYAxis.LabelAligment = System.Drawing.StringAlignment.Center;
			this.chartControl1.ShowLegend = false;
			this.chartControl1.Size = new System.Drawing.Size(392, 374);
			this.chartControl1.TabIndex = 0;
			this.chartControl1.Text = "EssentialChart";
			this.chartControl1.ToolBar.Location = new System.Drawing.Point(0, 0);
			this.chartControl1.ChartRegionMouseDown += new Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventHandler(this.chartControl1_ChartRegionMouseDown);
			//this.chartControl1.ChartRegionMouseHover += new Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventHandler(this.chartControl1_ChartRegionMouseHover);
			this.chartControl1.ChartRegionMouseMove += new Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventHandler(this.chartControl1_ChartRegionMouseMove);
			this.chartControl1.ChartRegionClick += new Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventHandler(this.chartControl1_ChartRegionClick);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(392, 374);
			this.Controls.Add(this.chartControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void InitializeControlSettings()
        {
            this.chartControl1.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));

            // Specify a ChartPalette:
            Color[] color = new Color[]{Color.FromArgb(185, 73,141,238), Color.FromArgb(185,247,179,78),Color.FromArgb(185,186,66,30)};
            this.chartControl1.Palette = ChartColorPalette.Custom ;
            this.chartControl1.Model.ColorModel.CustomColors = color;
            this.chartControl1.Palette = ChartColorPalette.Custom ;

            this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(185,new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, Color.LightBlue , Color.Azure));
            this.chartControl1.LegendPosition = ChartDock.Top;
            this.chartControl1.HidePartialLabels = true;
        }

		private void chartControl1_ChartRegionMouseDown(object sender, Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventArgs e)
		{
			if(e.Region.IsChartPoint)
			{
				Cursor = Cursors.SizeAll;
				this.isDragging = !this.isDragging;
				this.currentRegion = e.Region;
			}			
					
		
		}

		private void chartControl1_ChartRegionMouseMove(object sender, Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventArgs e)
		{
			
			
				if(this.isDragging)
				{
					GetAxisValues();

					//Screen Coordinates to ChartArea coordinates
					chartAreaPoint = ConvertScreenPointToChartAreaPoint(Control.MousePosition);

					this.chartControl1.Series[0].Points[this.currentRegion.PointIndex].X = GetXValueForScreenPoint(chartAreaPoint);
					this.chartControl1.Series[0].Points[this.currentRegion.PointIndex].YValues[0] = GetYValueForScreenPoint(chartAreaPoint);
					double newX = Math.Round(GetXValueForScreenPoint(Control.MousePosition),2) ;
					double newY = Math.Round(GetYValueForScreenPoint(Control.MousePosition),2) ;
					toolTip1.SetToolTip(chartControl1, newX +", "+newY);

                    this.chartControl1.Refresh();
					this.chartControl1.Redraw(true);
					
							

			}
			
			
			
		}
		bool clicked = false;

		private void chartControl1_ChartRegionClick(object sender, Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventArgs e)
		{
			

	
				clicked = !clicked;
				Point mousePoint = new Point( e.Point.X, e.Point.Y );
				ChartPoint chpt = chartControl1.ChartArea.GetValueByPoint(mousePoint);
				this.chartControl1.Series[0].Points[this.currentRegion.PointIndex].X =chpt.X;
				this.chartControl1.Series[0].Points[this.currentRegion.PointIndex].YValues[0]=chpt.YValues[0];

				if (!clicked)
				{
					this.isDragging = !this.isDragging;
					clicked = false;
				}	
				this.chartControl1.Refresh();
				this.chartControl1.Redraw(true);
			}

			
			
		

		private void Form1_Load(object sender, System.EventArgs e)
		{
			InitializeChartData();
		}

		protected void InitializeChartData()
		{
			ChartSeries series = this.chartControl1.Model.NewSeries("Drag and Drop Series",ChartSeriesType.Line);
			series.Text = series.Name;

			series.Points.Add(1,45);
			series.Points.Add(2,26);
			series.Points.Add(3,17);
            series.Points.Add(4,29);
            series.Points.Add(5,38);
            series.Points.Add(6,26);

            series.Style.Symbol.Shape = ChartSymbolShape.Circle;
            series.Style.Symbol.Size = new Size(5, 5);
            series.Style.Symbol.Color = Color.Red;

			
			this.chartControl1.Series.Add(series);
			
		}

		protected void GetAxisValues()
		{
			xmin = this.chartControl1.PrimaryXAxis.Range.Min;
			ymax = this.chartControl1.PrimaryYAxis.Range.Max;
			ymin = this.chartControl1.PrimaryYAxis.Range.Min;
			xmax = this.chartControl1.PrimaryXAxis.Range.Max;
		}

			
		

		private double GetXValueForScreenPoint(Point areaPoint)
		{
			Point axisStartPoint = this.chartControl1.GetChartAreaCoordinates(xmin,ymin);
			Point axisEndPoint = this.chartControl1.GetChartAreaCoordinates(xmax,ymin);
			Point axisZeroPoint = this.chartControl1.GetChartAreaCoordinates(0,ymin);

			// Pixel lengths
			double fullLength = axisEndPoint.X - axisStartPoint.X;
			double length = axisEndPoint.X - axisZeroPoint.X;
			double axisOrigin = this.chartControl1.ChartArea.ClientRectangle.Width - fullLength - this.chartControl1.ChartAreaMargins.Right;
			double pointX = chartAreaPoint.X - axisOrigin- axisZeroPoint.X;

			double returnVal = pointX/length * xmax;
			return returnVal;
		}

		private double GetYValueForScreenPoint(Point areaPoint)
		{
			Point axisStartPoint = this.chartControl1.GetChartAreaCoordinates(xmin,ymin);
			Point axisEndPoint = this.chartControl1.GetChartAreaCoordinates(xmin,ymax);
			Point axisZeroPoint = this.chartControl1.GetChartAreaCoordinates(0,ymin);

			// Pixel lengths
			double length = axisEndPoint.Y - axisZeroPoint.Y;
			double pointY = chartAreaPoint.Y -  axisZeroPoint.Y;

			double returnVal = pointY/length * ymax;
			return returnVal;
		}

		private Point ConvertScreenPointToChartAreaPoint(Point screenPoint)
		{
			Rectangle chartAreaRectangle = this.chartControl1.ChartArea.ClientRectangle;

			//We cant directly convert a Screen Point to Chart Area Coordinates
			//This converts the point in screen coordinates to chartcontrol coordinates
			Point ccp = this.chartControl1.PointToClient(screenPoint);

			//This converts the chart point into chartarea coordinates
			Point cap = new Point(ccp.X - chartAreaRectangle.X, ccp.Y - chartAreaRectangle.Y);

			return cap;
		}

				
		


		
	}
}
